Makefile: Set USE_PIC on x86-64
[gitweb.git] / git-rebase.sh
index f7b2b9401a90e5aa598daa6049ae5d33e5c5b157..3945e067141ec1bc87456179a59de8f692bdf9fa 100755 (executable)
 #
 
 USAGE='[--onto <newbase>] <upstream> [<branch>]'
-LONG_USAGE='git-rebase applies to <upstream> (or optionally to <newbase>) commits
-from <branch> that do not appear in <upstream>. When <branch> is not
-specified it defaults to the current branch (HEAD).
+LONG_USAGE='git-rebase replaces <branch> with a new branch of the
+same name.  When the --onto option is provided the new branch starts
+out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
+It then attempts to create a new commit for each commit from the original
+<branch> that does not exist in the <upstream> branch.
 
-When git-rebase is complete, <branch> will be updated to point to the
-newly created line of commit objects, so the previous line will not be
-accessible unless there are other references to it already.
+It is possible that a merge failure will prevent this process from being
+completely automatic.  You will have to resolve any such merge failure
+and run git rebase --continue.  Another option is to bypass the commit
+that caused the merge failure with git rebase --skip.  To restore the
+original <branch> and remove the .dotest working files, use the command
+git rebase --abort instead.
 
-Assuming the following history:
+Note that if <branch> is not specified on the command line, the
+currently checked out branch is used.  You must be in the top
+directory of your project to start (or continue) a rebase.
 
-          A---B---C topic
-         /
-    D---E---F---G master
+Example:       git-rebase master~1 topic
 
-The result of the following command:
+        A---B---C topic                   A'\''--B'\''--C'\'' topic
+       /                   -->           /
+  D---E---F---G master          D---E---F---G master
+'
+. git-sh-setup
 
-    git-rebase --onto master~1 master topic
+RESOLVEMSG="
+When you have resolved this problem run \"git rebase --continue\".
+If you would prefer to skip this patch, instead run \"git rebase --skip\".
+To restore the original branch and stop rebasing run \"git rebase --abort\".
+"
+unset newbase
+strategy=recursive
+do_merge=
+dotest=$GIT_DIR/.dotest-merge
+prec=4
 
-  would be:
+continue_merge () {
+       test -n "$prev_head" || die "prev_head must be defined"
+       test -d "$dotest" || die "$dotest directory does not exist"
 
-              A'\''--B'\''--C'\'' topic
-             /
-    D---E---F---G master
-'
+       unmerged=$(git-ls-files -u)
+       if test -n "$unmerged"
+       then
+               echo "You still have unmerged paths in your index"
+               echo "did you forget update-index?"
+               die "$RESOLVEMSG"
+       fi
 
-. git-sh-setup
+       if test -n "`git-diff-index HEAD`"
+       then
+               if ! git-commit -C "`cat $dotest/current`"
+               then
+                       echo "Commit failed, please do not call \"git commit\""
+                       echo "directly, but instead do one of the following: "
+                       die "$RESOLVEMSG"
+               fi
+               printf "Committed: %0${prec}d" $msgnum
+       else
+               printf "Already applied: %0${prec}d" $msgnum
+       fi
+       echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
+                               sed 's/^[a-f0-9]\+ //'`
+
+       prev_head=`git-rev-parse HEAD^0`
+       # save the resulting commit so we can read-tree on it later
+       echo "$prev_head" > "$dotest/prev_head"
+
+       # onto the next patch:
+       msgnum=$(($msgnum + 1))
+       echo "$msgnum" >"$dotest/msgnum"
+}
+
+call_merge () {
+       cmt="$(cat $dotest/cmt.$1)"
+       echo "$cmt" > "$dotest/current"
+       git-merge-$strategy "$cmt^" -- HEAD "$cmt"
+       rv=$?
+       case "$rv" in
+       0)
+               return
+               ;;
+       1)
+               test -d "$GIT_DIR/rr-cache" && git-rerere
+               die "$RESOLVEMSG"
+               ;;
+       2)
+               echo "Strategy: $rv $strategy failed, try another" 1>&2
+               die "$RESOLVEMSG"
+               ;;
+       *)
+               die "Unknown exit code ($rv) from command:" \
+                       "git-merge-$strategy $cmt^ -- HEAD $cmt"
+               ;;
+       esac
+}
+
+finish_rb_merge () {
+       rm -r "$dotest"
+       echo "All done."
+}
 
-unset newbase
 while case "$#" in 0) break ;; esac
 do
        case "$1" in
+       --continue)
+               diff=$(git-diff-files)
+               case "$diff" in
+               ?*)     echo "You must edit all merge conflicts and then"
+                       echo "mark them as resolved using git update-index"
+                       exit 1
+                       ;;
+               esac
+               if test -d "$dotest"
+               then
+                       prev_head="`cat $dotest/prev_head`"
+                       end="`cat $dotest/end`"
+                       msgnum="`cat $dotest/msgnum`"
+                       onto="`cat $dotest/onto`"
+                       continue_merge
+                       while test "$msgnum" -le "$end"
+                       do
+                               call_merge "$msgnum"
+                               continue_merge
+                       done
+                       finish_rb_merge
+                       exit
+               fi
+               git am --resolved --3way --resolvemsg="$RESOLVEMSG"
+               exit
+               ;;
+       --skip)
+               if test -d "$dotest"
+               then
+                       prev_head="`cat $dotest/prev_head`"
+                       end="`cat $dotest/end`"
+                       msgnum="`cat $dotest/msgnum`"
+                       msgnum=$(($msgnum + 1))
+                       onto="`cat $dotest/onto`"
+                       while test "$msgnum" -le "$end"
+                       do
+                               call_merge "$msgnum"
+                               continue_merge
+                       done
+                       finish_rb_merge
+                       exit
+               fi
+               git am -3 --skip --resolvemsg="$RESOLVEMSG"
+               exit
+               ;;
+       --abort)
+               if test -d "$dotest"
+               then
+                       rm -r "$dotest"
+               elif test -d .dotest
+               then
+                       rm -r .dotest
+               else
+                       die "No rebase in progress?"
+               fi
+               git reset --hard ORIG_HEAD
+               exit
+               ;;
        --onto)
                test 2 -le "$#" || usage
                newbase="$2"
                shift
                ;;
+       -M|-m|--m|--me|--mer|--merg|--merge)
+               do_merge=t
+               ;;
+       -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
+               --strateg=*|--strategy=*|\
+       -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
+               case "$#,$1" in
+               *,*=*)
+                       strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
+               1,*)
+                       usage ;;
+               *)
+                       strategy="$2"
+                       shift ;;
+               esac
+               do_merge=t
+               ;;
        -*)
                usage
                ;;
@@ -51,16 +199,25 @@ do
 done
 
 # Make sure we do not have .dotest
-if mkdir .dotest
+if test -z "$do_merge"
 then
-       rmdir .dotest
-else
-       echo >&2 '
+       if mkdir .dotest
+       then
+               rmdir .dotest
+       else
+               echo >&2 '
 It seems that I cannot create a .dotest directory, and I wonder if you
 are in the middle of patch application or another rebase.  If that is not
 the case, please rm -fr .dotest and run me again.  I am stopping in case
 you still have something valuable there.'
-       exit 1
+               exit 1
+       fi
+else
+       if test -d "$dotest"
+       then
+               die "previous dotest directory $dotest still exists." \
+                       'try git-rebase < --continue | --abort >'
+       fi
 fi
 
 # The tree must be really really clean.
@@ -128,5 +285,48 @@ then
        exit 0
 fi
 
-git-format-patch -k --stdout --full-index "$upstream" ORIG_HEAD |
-git am --binary -3 -k
+if test -z "$do_merge"
+then
+       git-format-patch -k --stdout --full-index "$upstream"..ORIG_HEAD |
+       git am --binary -3 -k --resolvemsg="$RESOLVEMSG"
+       exit $?
+fi
+
+if test "@@NO_PYTHON@@" && test "$strategy" = "recursive"
+then
+       die 'The recursive merge strategy currently relies on Python,
+which this installation of git was not configured with.  Please consider
+a different merge strategy (e.g. octopus, resolve, stupid, ours)
+or install Python and git with Python support.'
+
+fi
+
+# start doing a rebase with git-merge
+# this is rename-aware if the recursive (default) strategy is used
+
+mkdir -p "$dotest"
+echo "$onto" > "$dotest/onto"
+prev_head=`git-rev-parse HEAD^0`
+echo "$prev_head" > "$dotest/prev_head"
+
+msgnum=0
+for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
+                       | perl -e 'print reverse <>'`
+do
+       msgnum=$(($msgnum + 1))
+       echo "$cmt" > "$dotest/cmt.$msgnum"
+done
+
+echo 1 >"$dotest/msgnum"
+echo $msgnum >"$dotest/end"
+
+end=$msgnum
+msgnum=1
+
+while test "$msgnum" -le "$end"
+do
+       call_merge "$msgnum"
+       continue_merge
+done
+
+finish_rb_merge